<?php
$mtime = microtime();    
$mtime = explode(" ",$mtime);    
$mtime = $mtime[1] + $mtime[0];    
$totaltime = $mtime;

define("NORTH",1);
define("EAST",2);
define("SOUTH",4);
define("WEST",8);
define("UP",16);
define("DOWN",32);
define("STONE",64);
define("WOOD",128);
define("DIRT",256);
define("WATER",512);
define("BRICK",1024);
define("UNKNOWN",2048);


$linkhost = "localhost";
$linkname = "username";
$linkuser = "password";

function die404() {
      header("HTTP/1.1 404 Not Found");
?>
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head>
<title>404 Not Found</title>
</head><body>
<h1>Not Found</h1>
<p>The requested URL <?php print $_SERVER['REQUEST_URI']; ?> was not found on this server.</p>
<hr>
<?php print_r($_SERVER['SERVER_SIGNATURE']); ?>
</body></html>
<?php
      die;
}

if (isset($_GET['mapimg'])) {
	$exitbits = intval($_GET['mapimg']);
	
	header("Content-Type: image/png;");
	if ($exitbits & UNKNOWN) { $icon = imagecreatefrompng("unknown.png"); }
	elseif ($exitbits & STONE) { $icon = imagecreatefrompng("stone.png"); }
	elseif ($exitbits & WOOD) { $icon = imagecreatefrompng("wood.png"); }
	elseif ($exitbits & DIRT) { $icon = imagecreatefrompng("dirt.png"); }
	elseif ($exitbits & WATER) { $icon = imagecreatefrompng("water.png"); }
	elseif ($exitbits & BRICK) { $icon = imagecreatefrompng("brick.png"); }
	else { $icon = imagecreatefrompng("unknown.png"); }
	$map = imagecreatetruecolor(52,52);
	$background = imagecolorallocate($map,0,0,0);
	$black = imagecolorallocate($map,255,255,255);
	imagefill($map, 0, 0, $background);
	imagecopy($map,$icon,6,6,0,0,40,40);
	imagedestroy($icon);
	if ($exitbits & NORTH) { imageline($map,26,0,26,6,$black); }
	if ($exitbits & WEST) { imageline($map,0,26,6,26,$black); }
	if ($exitbits & EAST) { imageline($map,46,26,52,26,$black); }
	if ($exitbits & SOUTH) { imageline($map,26,46,26,52,$black); }
	if ($exitbits & UP) { imageline($map,2,12,2,19,$black); imageline($map,2,12,0,14,$black); imageline($map,2,12,4,14,$black); }
	if ($exitbits & DOWN) { imageline($map,2,19,2,12,$black); imageline($map,2,19,0,17,$black); imageline($map,2,19,4,17,$black); }
	imagepng($map);
	imagedestroy($map);
	exit;
}
?>
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head>
<style>
input#invaction,a:link {
    background: transparent;
    border: 0;
    cursor:pointer;
    margin: 0;
    padding: 0;
    color: #0000C0;
    text-decoration: underline;
}

input#invaction:visited,a:visited {
    color: #0000C0;
}

input#invaction:hover,a:hover {
    color: #8080FF;
    text-decoration: none;
}

input#invaction:active,a:active  {
    color: #9F3FFF;
}
</style>
<title>Engine 0.003</title>
</head><body>
<a href="?reboot">Restart the game</a>!<p>
<?php
if (isset($_GET['reboot'])) { 
	session_start(); session_destroy();
	echo "This was just a quick project to see how difficult it would be to write a basic adventure style engine in PHP.  If you'd like all the code that can be downloaded <a href=\"code.tar.xz\">here</a>.";
}

//Start all database links
$link = mysql_connect($linkhost,$linkuser,"") or die("No Database Connection");
@mysql_select_db($linkname) or die("Database Select Failed");
session_start();
$stats = ""; $usable = ""; $talkable = ""; $takable = ""; $objects = ""; $people = ""; $event = ""; $exits = ""; $wait = FALSE;
if (!isset($_SESSION['room_id'])) { 
	$_SESSION['room_id'] = 0;
	$_SESSION['_mappos'] = array(25,25,25);
	$_SESSION['_wgt'] = 0;
	$_SESSION['_hgr'] = 0;
	$_SESSION['_timer0'] = -1;
	$_SESSION['_movements'] = 0;
}

if (isset($_GET['move'])) {
	$room_id = $_SESSION['room_id'] . "_";
	$query = mysql_query('SELECT exits FROM rooms WHERE room_id = '. mysql_real_escape_string(intval($_SESSION['room_id'])));
	if ($row = mysql_fetch_assoc($query)) {
		$description = explode("\n",$row['exits']);
		foreach ($description as $text) {
			$item = explode(':',$text);
			if (strtoupper($item[0]) == strtoupper($_GET['move']) && (!isset($item[3]) || compare_objects($room_id,$item[3],$item[4]) == TRUE)) { 
				$_SESSION['room_id'] = intval($item[1]);
				$_SESSION['_movements']++;
				if ($_SESSION['_movements'] % 10 == 0) { echo "!"; $stats[] = "++1HGR"; }
				switch (strtoupper($_GET['move'])) {
						case "NORTH": $_SESSION['_mappos'][1]++; break;
						case "EAST": $_SESSION['_mappos'][0]++; break;
						case "SOUTH": $_SESSION['_mappos'][1]--; break;
						case "WEST": $_SESSION['_mappos'][0]--; break;
						case "UP": $_SESSION['_mappos'][2]++; break;
						case "DOWN": $_SESSION['_mappos'][2]--; break;
				}
			}
		}
	}	
}
 
$_SESSION['_timer0']++;
$room_id = intval($_SESSION['room_id']) . '_';
$query = mysql_query('SELECT * FROM rooms WHERE room_id = '. mysql_real_escape_string(intval($_SESSION['room_id'])));
if ($row = mysql_fetch_assoc($query)) {
	echo '<form action="index.php" method="get"><table border="1">';
	echo '<tr><td colspan="3"><u>' . $row['name'] .'</u> <font size="-2">Room ID: '.$row['room_id']."</font></td></tr>";
	$exits = $row['exits'];
	$roomtype = $row['ground'];
	
	if ($row['objects'] > 0) {
		$subquery = mysql_query('SELECT * FROM object, objects WHERE room_id = '. mysql_real_escape_string($row['objects']) . ' AND object.id = objects.id ');
		while ($subrow = mysql_fetch_assoc($subquery)) {
			if (strpos($subrow['description'],'@') !== FALSE && $subrow['function'] > 0 && !isset($_SESSION[$room_id.$subrow['name']])) { $_SESSION[$room_id.$subrow['name']] = $subrow['state']; }
			
			if (isset($_GET[$subrow['name']])) {
				if ($subrow['function'] > 0 && $_SESSION[$room_id.$subrow['name']] == -1) { continue; }
				$description = explode('@',$subrow['on_use']);
				foreach ($description as $value => $text) {
					if ($value == 0) { $event .= '<b>' . $text . '</b>'; }
					else {
						$item = explode(':',$text);
						if (count($item) == 2) { array_unshift($item,$subrow['name']); }
						if (compare_objects($room_id,$item[0],$item[1]) == TRUE) {
							if (strpos($item[2],'==') !== FALSE) { $_SESSION[$room_id.$subrow['name']] = intval(substr($item[2],strpos($item[2],'==') + 2)); $item[2] = substr($item[2],0,strpos($item[2],'==')); }
							if (strpos($item[2],'++') !== FALSE) { $stats[] = trim(substr($item[2],strpos($item[2],'++'))); $item[2] = substr($item[2],0,strpos($item[2],'++')); }
							if (strpos($item[2],'--') !== FALSE) { $stats[] = trim(substr($item[2],strpos($item[2],'--'))); $item[2] = substr($item[2],0,strpos($item[2],'--')); }
							$event .= '<b>' . $item[2] . '</b><br>';
						}
					}
				}
				switch ($subrow['function']) {
					case 1: if ($_SESSION[$room_id.$subrow['name']] == 1) { $_SESSION[$room_id.$subrow['name']] = 0; } else { $_SESSION[$room_id.$subrow['name']] = 1; } break;
					case 2: $_SESSION[$room_id.$subrow['name']]++; break;
					case 3: $_SESSION[$room_id.$subrow['name']]--; break;
				}
				if ($subrow['can_take'] == 1) {
					if ($_SESSION[$room_id.$subrow['name']] == 1) {
						$_SESSION[$room_id.$subrow['name']] = -1;
						$_SESSION['_'.$subrow['name']] = 1;
						$_SESSION['_inv'][] = $subrow['id'];
					}
				}
			}
			
			if (strlen($subrow['on_use']) > 0) {
				if ($subrow['function'] == 4) {
					if (isset($_GET['talk'])) {
						$description = explode('@',$subrow['on_use']);
						foreach ($description as $text) {
							$item = explode(':',$text);
							if ($_SESSION[$room_id.$subrow['name']] == $item[0] && crc32($item[1]) == $_GET['talk']) {
								if (strpos($item[1],'==') !== FALSE) { $_SESSION[$room_id.$subrow['name']] = intval(substr($item[1],strpos($item[1],'==') + 2)); }
								if (strpos($item[1],'++') !== FALSE) { $stats[] = trim(substr($item[1],strpos($item[1],'++'))); }
								if (strpos($item[1],'--') !== FALSE) { $stats[] = trim(substr($item[1],strpos($item[1],'--'))); }
							}								
						}
					}
					$description = explode('@',$subrow['on_use']);
					foreach ($description as $text) {
						$item = explode(':',$text);
						if ($_SESSION[$room_id.$subrow['name']] == $item[0]) { $talkable[] = $item[1]; }
					}
				} 
				elseif ($subrow['function'] == 0 || $_SESSION[$room_id.$subrow['name']] != -1) {
					if ($subrow['can_take'] == 1) { $takable[] = $subrow['name']; } 
					else { $usable[] = $subrow['name']; }
				}
			}
			
			if ($subrow['function'] == 4) { $people[$subrow['name']] = $subrow['description']; }
			elseif ($_SESSION[$room_id.$subrow['name']] != -1) { $objects[$subrow['name']] = $subrow['description']; }
		}
	}
	if ($row['timers'] != "") {
		$description = explode("\n",$row['timers']);
		foreach ($description as $text) {
			$item = explode(':',trim($text));
			//echo "Timers!  compare_objects(".$room_id.','.$item[3].','.$item[4].')<br>';
			if ($item[3] == "" || compare_objects($room_id,$item[3],$item[4]) == TRUE) {
				$wait = TRUE;
				if (!isset($_SESSION[$room_id.$item[0]])) { $_SESSION[$room_id.$item[0]] = $item[2]; }
				else {
					if ($item[1] == 1) { $_SESSION[$room_id.$item[0]]++; }
					else { $_SESSION[$room_id.$item[0]]--; }
				}
			}
		}
	}

	echo '<tr><td width="125" valign="top">';
	if (isset($_SESSION['_inv'])) {
		echo '<center>';
		$subquery = "";
		foreach ($_SESSION['_inv'] as $item) {
			$subquery .= intval($item) . ',';
		}
		$subquery = mysql_query('SELECT * FROM object WHERE id IN ('. mysql_real_escape_string(substr($subquery,0,-1)) .')');
		while ($subrow = mysql_fetch_assoc($subquery)) {
			echo '<label for="'.$subrow['name'].'">'.$subrow['name'];
			echo '<input type="radio" name="invitem" id="'.$subrow['name'].'" value="'.$subrow['name'].'"></label><p>';
			
			if (isset($_GET['invaction']) && isset($_GET['invitem']) && $_GET['invitem'] == $subrow['name']) {
				if ($_GET['invaction'] == 'Use') {
					$description = explode('@',$subrow['on_use']);
					foreach ($description as $value => $text) {
						if ($value == 0 && strlen($text) > 0) { $event .= '<b>' . $text . '</b>'; }
						else {
							$item = explode(':',$text);
							if (count($item) == 2) { array_unshift($item,$subrow['name']); }
							if (compare_objects('_',$item[0],$item[1]) == TRUE) {
								if (strpos($item[2],'==') !== FALSE) { $_SESSION['_'.$subrow['name']] = intval(substr($item[2],strpos($item[2],'==') + 2)); $item[2] = substr($item[2],0,strpos($item[2],'==')); }
								if (strpos($item[2],'++') !== FALSE) { $_SESSION['_'.$subrow['name']]++; $item[2] = substr($item[2],0,strpos($item[2],'++')); }
								if (strpos($item[2],'--') !== FALSE) { $_SESSION['_'.$subrow['name']]++; $item[2] = substr($item[2],0,strpos($item[2],'--')); }
								if (strlen($item[2]) > 0) { $event .= '<b>' . $item[2] . '</b><br>'; }
							}
						}
					}
				}
				elseif ($_GET['invaction'] == 'Examine') {
					$description = explode('@',$subrow['description']);
					foreach ($description as $value => $text) {
						if ($value == 0 && strlen($text) > 0) { $event .= '<b>' . $text . '</b>'; }
						else {
							$item = explode(':',$text);
							if (count($item) == 2) { array_unshift($item,$subrow['name']); }
							if (compare_objects('_',$item[0],$item[1]) == TRUE) {
								if (strpos($item[2],'==') !== FALSE) { $_SESSION['_'.$subrow['name']] = intval(substr($item[2],strpos($item[2],'==') + 2)); $item[2] = substr($item[2],0,strpos($item[2],'==')); }
								if (strpos($item[2],'++') !== FALSE) { $_SESSION['_'.$subrow['name']]++; $item[2] = substr($item[2],0,strpos($item[2],'++')); }
								if (strpos($item[2],'--') !== FALSE) { $_SESSION['_'.$subrow['name']]--; $item[2] = substr($item[2],0,strpos($item[2],'--')); }
								if (strlen($item[2]) > 0) { $event .= '<b>' . $item[2] . '</b><br>'; }
							}
						}
					}
				}
			}
			$description = explode('@',$subrow['on_event']);
			foreach ($description as $value => $text) {
				if ($value == 0 && strlen($text) > 0) { $event .= '<b>' . $text . '</b>'; }
				else {
					$item = explode(':',$text);
					if (count($item) == 2) { array_unshift($item,$subrow['name']); }
					if (compare_objects('_',$item[0],$item[1]) == TRUE) {
						if (strpos($item[2],'==') !== FALSE) { $_SESSION['_'.$subrow['name']] = intval(substr($item[2],strpos($item[2],'==') + 2)); $item[2] = substr($item[2],0,strpos($item[2],'==')); }
						if (strpos($item[2],'++') !== FALSE) { $_SESSION['_'.$subrow['name']]++; $item[2] = substr($item[2],0,strpos($item[2],'++')); }
						if (strpos($item[2],'--') !== FALSE) { $_SESSION['_'.$subrow['name']]--; $item[2] = substr($item[2],0,strpos($item[2],'--')); }
						if (strlen($item[2]) > 0) { $event .= '<b>' . $item[2] . '</b><br>'; }
					}
				}
			}
		}
		echo '</center>';
	}
	echo '</td><td width="800">';	
	if (isset($_GET['map'])) {
		echo "You pull out the dusty paper you've been keeping notes on.";
		echo build_map(4,4);
	}
	else {
		$description = explode('@',$row['description']);
		foreach ($description as $value => $text) {
			if ($value == 0) { echo $text; }
			else {
				$item = explode(':',trim($text));
				if (compare_objects($room_id,$item[0],$item[1]) == TRUE) {
					if (strpos($item[2],'>>') !== FALSE) { $_SESSION['room_id'] = trim(substr($item[2],strpos($item[2],'>>') + 2)); $item[2] = substr($item[2],0,strpos($item[2],'>>')); $usable = ""; $talkable = ""; $exits = ""; $wait = TRUE; }
					if (strpos($item[2],'++') !== FALSE) { $stats[] = trim(substr($item[2],strpos($item[2],'++'))); $item[2] = substr($item[2],0,strpos($item[2],'++')); }
					if (strpos($item[2],'--') !== FALSE) { $stats[] = trim(substr($item[2],strpos($item[2],'--'))); $item[2] = substr($item[2],0,strpos($item[2],'--')); }
					echo '<br><b>' .$item[2] . '</b>';
				}
			}
		}
	}
	
	$output = "";
	if ($people != "") {
		foreach ($people as $key => $text) {
			$fullitem = "";
			$description = explode('@',$text);
			for ($value = count($description) - 1; $value >= 0; $value--) {
				$text = $description[$value];
				if ($value == 0) { $fullitem = $text . $fullitem; }
				else {
					$item = explode(':',$text);
					if ($_SESSION[$room_id.$key] == $item[0]) {
						if (strpos($item[1],'==') !== FALSE) { $_SESSION[$room_id.$key] = intval(substr($item[1],strpos($item[1],'==') + 2)); $item[1] = substr($item[1],0,strpos($item[1],'==')); }
						if (strpos($item[1],'++') !== FALSE) { $stats[] = trim(substr($item[1],strpos($item[1],'++'))); $item[1] = substr($item[1],0,strpos($item[1],'++')); }
						if (strpos($item[1],'--') !== FALSE) { $stats[] = trim(substr($item[1],strpos($item[1],'--'))); $item[1] = substr($item[1],0,strpos($item[1],'--')); }
						if (substr($item[1],0,1) == '!') { $fullitem .= substr($item[1],1); }
						else { $event .= '<b>' . $item[1] . '</b><br>'; }
					}
				}
			}
			if ($_SESSION[$room_id.$key] != -1) { $output .= '<li>' . trim($fullitem) . '</li>'; }
		}
	}
	
	if ($objects != "") {
		foreach ($objects as $key => $text) {
			$description = explode('@',$text);
			for ($value = count($description) - 1; $value >= 0; $value--) {
				$text = $description[$value];
				if ($value == 0) { $output = "<li>" . $text . $output; }
				else {
					$item = explode(':',$text);
					if ($_SESSION[$room_id.$key] == $item[0]) {
						if (strpos($item[1],'==') !== FALSE) { $_SESSION[$room_id.$key] = intval(substr($item[1],strpos($item[1],'==') + 2)); $item[1] = substr($item[1],0,strpos($item[1],'==')); }
						if (strpos($item[1],'++') !== FALSE) { $stats[] = trim(substr($item[1],strpos($item[1],'++'))); $item[1] = substr($item[1],0,strpos($item[1],'++')); }
						if (strpos($item[1],'--') !== FALSE) { $stats[] = trim(substr($item[1],strpos($item[1],'--'))); $item[1] = substr($item[1],0,strpos($item[1],'--')); }
						$output = '<b>' . $item[1] . '</b></li>' . $output;
					}
				}
			}
		}
	}
	if ($output != "") { echo '<p>You see before you:<ul>' . $output . '</ul>'; }
	
	echo '</td>';
	
	$exitbits = 0;
	if ($exits != "") {
		$description = explode("\n",$exits);
		natcasesort($description);
		foreach ($description as $text) {
			$item = explode(':',trim($text));
			if (!isset($item[2]) || compare_objects($room_id,$item[2],$item[3]) == TRUE) {
				switch (strtoupper($item[0])) {
					case "NORTH": $exitbits = $exitbits | NORTH; break;
					case "EAST": $exitbits = $exitbits | EAST; break;
					case "SOUTH": $exitbits = $exitbits | SOUTH; break;
					case "WEST": $exitbits = $exitbits | WEST; break;
					case "UP": $exitbits = $exitbits | UP; break;
					case "DOWN": $exitbits = $exitbits | DOWN; break;
				}
			}
		}
	}
		
	$compass = build_compass($exitbits,$roomtype);
	
	echo '<td bgcolor="#000000"><center>';
	
	echo '<img src="cave.jpg"><br>';
	echo build_map(1,1);
	
	echo '</center></td></tr>';

	if ($event != "" || is_array($stats)) {
		echo '<tr><td colspan="3">' . substr($event,0,-4);
		
		if (is_array($stats)) {
			$_hgr = 0; $_wgt = 0; $_hgramt = 0; $_wgtamt = 0; 
			echo "<p><b>";
			foreach ($stats as $value) {
				$amount = intval(substr($value,2));
				switch (strtoupper(substr($value,0,2).substr($value,-3))) {
					case "++HGR": $_SESSION['_hgr'] = $_SESSION['_hgr'] + $amount; $_hgr+=$amount; $_hgramt+=$amount; break;
					case "--HGR": $_SESSION['_hgr'] = $_SESSION['_hgr'] - $amount; $_hgr-=$amount; $_hgramt+=$amount; break;
					case "++WGT": $_SESSION['_wgt'] = $_SESSION['_wgt'] + $amount; $_wgt+=$amount; $_wgtamt+=$amount; break;
					case "--WGT": $_SESSION['_wgt'] = $_SESSION['_wgt'] - $amount; $_wgt-=$amount; $_wgtamt+=$amount; break;
				}
			}
			if ($_hgr != 0) {
				echo "You're feeling ".($_hgr > 0 ? 'more' : 'less')." hungry.  ";
				echo "<p>This should be descriptive text describing the amount of change, which in this case is " . $_hgramt;
				if ($_SESSION['_hgr'] >= 10) { echo "<p>You're starving.  The room seems to vagly spin around you as you try to keep your balance."; }
				elseif ($_SESSION['_hgr'] >= 5) { echo "<p>Your stomach gurgles loudly.  You're feeling faint."; }
				else { echo "<p>Your stomach gurgles."; }
				
			}
			if ($_wgt != 0) {
				echo "You feel... " . ($_wgt > 0 ? 'fatter' : 'thinner') . ".  ";
				echo "<p>This should be descriptive text describing the amount of change, which in this case is " . $_hgramt;
				if ($_SESSION['_wgt'] >= 25) { echo "<p>Your clothing stuggles to contain your increased bulk."; }
				elseif ($_SESSION['_wgt'] >= 10) { echo "<p>Your clothing feels a little more constricting..."; }
				elseif ($_wgt > 0) { echo "<p>A warm feeling fills your body."; }
				else { echo "<p>An empty feeling fills your body."; }
				
			}
			echo "</b></p>";
		}
		echo '</td></tr>';
	}

	echo '<tr><td valign="top"><center>With the item above:<p>';
	echo '<input id="invaction" name="invaction" type="submit" value="Use"><p><input id="invaction" name="invaction" type="submit" value="Examine"></center>';
	echo '</td><td valign="top">What would you like to do?<br>';
	if ($talkable != "") {
		foreach ($talkable as $text) {
			echo '<br>Say <A HREF="?talk=' . crc32($text) . '">';
			if (strpos($text,'==') !== FALSE) { $text = substr($text,0,strpos($text,'==')); }
			if (strpos($text,'++') !== FALSE) { $text = substr($text,0,strpos($text,'++')); }
			if (strpos($text,'--') !== FALSE) { $text = substr($text,0,strpos($text,'--')); }
			echo $text . "</a>\n";
		}	
	}
	if ($takable != "") {
		foreach ($takable as $text) {
			echo '<br>Take the <A HREF="?' . $text . '">'. $text . "</a>\n";
		}	
	}
	if ($usable != "") {
		foreach ($usable as $text) {
			echo '<br>Use the <A HREF="?' . $text . '">'. $text . "</a>\n";
		}	
	}
	if (isset($_GET['map'])) { echo '<br>Put away your <A HREF="?">map</a>'; }
	else { echo '<br>Look at your <A HREF="?map">map</a>'; }

	if ($wait == TRUE) {
		echo '<br><A HREF="index.php">Wait here</a>';
	}
	echo '</td><td align="center" valign="middle">';
	
	echo $compass;
	
	echo '</td></tr></table></form>';

	//echo "<br><p><br><p><font size='-1'>Normally you wouldn't see this. Session data:</font><pre>"; print_r($_SESSION); echo "</pre>";
	//echo "<!-- Current Data Status:\n"; print_r($_SESSION); echo "\n -->";
	echo '</body></html>';
}

function build_map($xscale, $yscale){
	$output = '<table cellpadding="0" cellspacing="0">';
	$z = $_SESSION['_mappos'][2];
	for ($y = $_SESSION['_mappos'][1] + $yscale; $y >= $_SESSION['_mappos'][1] - $yscale; $y--) {
		$output .= '<tr>';
		for ($x = $_SESSION['_mappos'][0] - $xscale; $x <= $_SESSION['_mappos'][0] + $xscale; $x++) {
			if (!isset($_SESSION['_map'][$x][$y][$z])) { $output .= '<td bgcolor="#000000" width="52" height="52">&nbsp;</td>'; }
			else {
				if (isset($_SESSION['_map'][$x][$y][$z])) { $location = $_SESSION['_map'][$x][$y][$z]; }
				else { $location = UNKNOWN; }
				$output .= '<td><img src="?mapimg=' . $location . '" width="52" height="52"></td>';
			}
		}
		$output .= '</tr>';
	}
	$output .= '</table>';
	
	return $output;
}

function build_compass($exitbits, $roomtype) {
	$output = '<table border="1"><tr><td>';
	
	$_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2]] = $exitbits | $roomtype;
	if ($exitbits & UP)   { 
		$_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2] + 1] = $_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2] + 1] | DOWN;
		$output .= '<A HREF="?move=UP"><img src="up.png"></a>';
	}
	else {
		$_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2] + 1] = $_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2] + 1] & ~ DOWN;
		$output .= '&nbsp;';
	}
	$output .= '</td><td>';
	
	if ($exitbits & NORTH) {
		$_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1] + 1][$_SESSION['_mappos'][2]] = $_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1] + 1][$_SESSION['_mappos'][2]] | SOUTH;
		$output .= '<A HREF="?move=NORTH"><img src="north.png"></a>';
	}
	else {
		$_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1] + 1][$_SESSION['_mappos'][2]] = $_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1] + 1][$_SESSION['_mappos'][2]] & ~ SOUTH;
		$output .= '<img src="north-disabled.png">';
	}
	$output .= '</td><td>';
	 
	if ($exitbits & DOWN) {
		$_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2] - 1] = $_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2] - 1] | UP;
		$output .= '<A HREF="?move=DOWN"><img src="down.png"></a>';
	}
	else {
		$_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2] - 1] = $_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2] - 1] & ~ UP;
		$output .= '&nbsp;';
	}
	$output .= '</td></tr><td>';

	if ($exitbits & WEST) {
		$_SESSION['_map'][$_SESSION['_mappos'][0] - 1][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2]] = $_SESSION['_map'][$_SESSION['_mappos'][0] - 1][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2]] | EAST;
		$output .= '<A HREF="?move=WEST"><img src="west.png"></a>';
	}
	else {
		$_SESSION['_map'][$_SESSION['_mappos'][0] - 1][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2]] = $_SESSION['_map'][$_SESSION['_mappos'][0] - 1][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2]] & ~ EAST;
		$output .= '<img src="west-disabled.png">';
	}
	$output .= '</td><td>&nbsp;</td><td>';

	if ($exitbits & EAST) {
		$_SESSION['_map'][$_SESSION['_mappos'][0] + 1][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2]] = $_SESSION['_map'][$_SESSION['_mappos'][0] + 1][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2]] | WEST;
		$output .= '<A HREF="?move=EAST"><img src="east.png"></a>';
	}
	else {
		$_SESSION['_map'][$_SESSION['_mappos'][0] + 1][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2]] = $_SESSION['_map'][$_SESSION['_mappos'][0] + 1][$_SESSION['_mappos'][1]][$_SESSION['_mappos'][2]] & ~ WEST;
		$output .= '<img src="east-disabled.png">';
	}
	$output .= '</td></tr><tr><td>&nbsp;</td><td>';

	if ($exitbits & SOUTH) {
		$_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1] - 1][$_SESSION['_mappos'][2]] = $_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1] - 1][$_SESSION['_mappos'][2]] | NORTH;
		$output .= '<A HREF="?move=SOUTH"><img src="south.png"></a>';
	}
	else {
		$_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1] - 1][$_SESSION['_mappos'][2]] = $_SESSION['_map'][$_SESSION['_mappos'][0]][$_SESSION['_mappos'][1] - 1][$_SESSION['_mappos'][2]] & ~ NORTH;
		$output .= '<img src="south-disabled.png">';
	}
	$output .=  '</td><td>&nbsp;</td></tr></table>';
	
	return $output;
}

function compare_objects($room_id,$state,$compare) {
	$states = explode(';',trim($state));
	$compares = explode(';',trim($compare));

	for ($key = 0; $key < count($states); $key++) {
		if (strpos($states[$key],'_') !== FALSE) { $state = $_SESSION[$states[$key]]; }
		elseif (isset($_SESSION[$room_id.$states[$key]])) { $state = $_SESSION[$room_id.$states[$key]]; }
		else { $state = 0; }
		$oper = 1;
		$compare = intval($compares[$key]);
		
		if (strpos($compares[$key],'+') !== FALSE) { $oper = 2; }
		elseif (strpos($compares[$key],'-') !== FALSE) { $oper = 3; }
		//echo "<br> O $oper S $state C $compare <br>";

		if (($state != $compare && $oper == 1) || ($state <= $compare && $oper == 2) || ($state >= $compare && $oper == 3)) { return FALSE; }
	}
	return TRUE;
	
}
